/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 * 
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tud.kom.p2psim.impl.churn.views;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;

import de.tud.kom.p2psim.impl.churn.ChurnInfo;
import de.tudarmstadt.maki.simonstrator.api.component.GlobalComponent;

public class ListView  extends JFrame implements GlobalComponent {
	DefaultListModel<ChurnInfo> model = new DefaultListModel<>();
	JList<ChurnInfo> list;
	
	int currentElement = 0;
	
	public ListView() {
		super();
		this.setTitle("Queued Churn elements");
		this.setLayout(new GridLayout(2,1));
		
		this.list = new JList<>(model);
		this.add(list);
		
		JButton deleteButton = new JButton("Delete selceted Churn");
		deleteButton.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				System.out.println("Selected Elem: " + list.getSelectedIndex());
				System.out.println("Current Elem: " + currentElement);
				if(list.getSelectedIndex() != -1 && list.getSelectedIndex() >= currentElement) {
					model.remove(list.getSelectedIndex());
				}
			}
		});
		
		this.add(deleteButton);
		
		this.setSize(250, 300);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setEnabled(true);
		this.setVisible(true);
	}
	
	public void addChurn(ChurnInfo event) {
		this.model.addElement(event);
	}
	
	public DefaultListModel<ChurnInfo> getModel() {
		return this.model;
	}
	
	public void setCurrentElement(int currentElement) {
		this.currentElement = currentElement;
	}
}
